/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20141107-64 [Jan  2 2015]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of SSDT2.aml, Fri Apr 10 15:16:18 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000008BB (2235)
 *     Revision         0x01
 *     Checksum         0x59
 *     OEM ID           "ACRSYS"
 *     OEM Table ID     "ACRPRDCT"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "1025"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT2.aml", "SSDT", 1, "ACRSYS", "ACRPRDCT", 0x00001000)
{

    External (_SB_.PCI0.LPCB.EC0_.CDTB, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.CMDB, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.EDAB, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.ESEB, FieldUnitObj)
    External (_SB_.PCI0.LPCB.EC0_.MUEC, MutexObj)
    External (_SB_.PCI0.LPCB.EC0_.PCPT, FieldUnitObj)
    External (_TZ_._TMP, IntObj)
    External (TBAB, FieldUnitObj)

    Scope (\_SB)
    {
        Device (PTID)
        {
            Name (_HID, EisaId ("INT340E"))  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0C02"))  // _CID: Compatible ID
            Name (IVER, 0x00030000)
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (0x0F)
            }

            Name (TSDL, Package (0x2E)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "CPU Core VR (IMVP) Temperature", 
                0x03, 
                "CPU GT VR (IMVP) Temperature", 
                0x03, 
                "Heat Exchanger Fan Temperature", 
                0x03, 
                "Skin Temperature", 
                0x03, 
                "Ambient Temperature", 
                0x03, 
                "Minicard Region Temperature", 
                0x02, 
                "Channel 0 DIMM Temperature", 
                0x02, 
                "Channel 1 DIMM Temperature", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TS-on-DIMM0 Temperature", 
                0x02, 
                "TS-on-DIMM1 Temperature", 
                0x02, 
                "TS-on-DIMM2 Temperature", 
                0x02, 
                "TS-on-DIMM3 Temperature", 
                0x02, 
                "TZ00 _TMP", 
                0x02, 
                "TZ01 _TMP"
            })
            Name (PSDL, Package (0x0C)
            {
                Zero, 
                "CPU Power", 
                One, 
                "Gfx Core Power", 
                0x0A, 
                "System Power", 
                Zero, 
                "CPU Average Power", 
                One, 
                "Gfx Core Average Power", 
                0x0A, 
                "System Average Power"
            })
            Name (OSDL, Package (0x06)
            {
                Zero, 
                "CPU Fan Speed", 
                "RPM", 
                Zero, 
                "CPU energy", 
                "RAW"
            })
            Method (TSDD, 0, NotSerialized)
            {
                Name (TMPV, Package (0x17)
                {
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000
                })
                Index (TMPV, Zero) = 0x0BD8
                Index (TMPV, One) = 0x0BE2
                Index (TMPV, 0x02) = 0x0BEC
                Index (TMPV, 0x03) = 0x0BF6
                Index (TMPV, 0x04) = 0x0C00
                Index (TMPV, 0x05) = 0x0C0A
                Index (TMPV, 0x06) = 0x0C14
                Index (TMPV, 0x07) = 0x0C1E
                Index (TMPV, 0x08) = 0x0C28
                Index (TMPV, 0x09) = 0x0C32
                Index (TMPV, 0x0A) = 0x0C3C
                If ((TBAB != Zero))
                {
                    Index (TMPV, 0x0B) = ((\_SB.PCI0.LPCB.EC0.PCPT * 0x0A) + 0x0AAC)
                }

                Index (TMPV, 0x0C) = 0x0C46
                Index (TMPV, 0x0D) = 0x0C50
                Index (TMPV, 0x0E) = 0x0C5A
                Index (TMPV, 0x0F) = 0x0C64
                Index (TMPV, 0x10) = 0x0C6E
                Index (TMPV, 0x11) = \_TZ._TMP
                Index (TMPV, 0x12) = \_TZ._TMP
                Return (TMPV)
            }

            Method (PSDD, 0, NotSerialized)
            {
                Name (PWRV, Package (0x06)
                {
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000
                })
                Return (PWRV)
            }

            Method (OSDD, 0, NotSerialized)
            {
                Name (OSDV, Package (0x02)
                {
                    0x80000000, 
                    0x80000000
                })
                Return (OSDV)
            }

            Method (SDSP, 0, NotSerialized)
            {
                Return (0x0A)
            }

            Name (PADA, Package (0x0A)
            {
                One, 
                Ones, 
                Ones, 
                0x1A, 
                Ones, 
                Ones, 
                Ones, 
                Ones, 
                Ones, 
                Ones
            })
            Name (PADD, Package (0x0A)
            {
                0x02, 
                0x06A4, 
                0x06A0, 
                0x1A, 
                0x62, 
                0x63, 
                0x60, 
                0x61, 
                0x65, 
                0x64
            })
            Method (PADT, 0, NotSerialized)
            {
                Return (PADA)
            }

            Name (MTMP, Buffer (0x1A) {})
            Name (PTIE, Zero)
            Method (RPMD, 0, NotSerialized)
            {
                Return (MTMP)
            }

            Method (WPMD, 1, NotSerialized)
            {
                If ((SizeOf (Arg0) != 0x1A))
                {
                    Return (Ones)
                }

                Index (MTMP, Zero) = DerefOf (Index (Arg0, Zero))
                Index (MTMP, One) = DerefOf (Index (Arg0, One))
                Index (MTMP, 0x02) = DerefOf (Index (Arg0, 0x02))
                Index (MTMP, 0x03) = DerefOf (Index (Arg0, 0x03))
                Index (MTMP, 0x04) = DerefOf (Index (Arg0, 0x04))
                Index (MTMP, 0x05) = DerefOf (Index (Arg0, 0x05))
                Index (MTMP, 0x06) = DerefOf (Index (Arg0, 0x06))
                Index (MTMP, 0x07) = DerefOf (Index (Arg0, 0x07))
                Index (MTMP, 0x08) = DerefOf (Index (Arg0, 0x08))
                Index (MTMP, 0x09) = DerefOf (Index (Arg0, 0x09))
                Index (MTMP, 0x0A) = DerefOf (Index (Arg0, 0x0A))
                Index (MTMP, 0x0B) = DerefOf (Index (Arg0, 0x0B))
                Index (MTMP, 0x0C) = DerefOf (Index (Arg0, 0x0C))
                Index (MTMP, 0x0D) = DerefOf (Index (Arg0, 0x0D))
                Index (MTMP, 0x0E) = DerefOf (Index (Arg0, 0x0E))
                Index (MTMP, 0x0F) = DerefOf (Index (Arg0, 0x0F))
                Index (MTMP, 0x10) = DerefOf (Index (Arg0, 0x10))
                Index (MTMP, 0x11) = DerefOf (Index (Arg0, 0x11))
                Index (MTMP, 0x12) = DerefOf (Index (Arg0, 0x12))
                Index (MTMP, 0x13) = DerefOf (Index (Arg0, 0x13))
                Index (MTMP, 0x14) = DerefOf (Index (Arg0, 0x14))
                Index (MTMP, 0x15) = DerefOf (Index (Arg0, 0x15))
                Index (MTMP, 0x16) = DerefOf (Index (Arg0, 0x16))
                Index (MTMP, 0x17) = DerefOf (Index (Arg0, 0x17))
                Index (MTMP, 0x18) = DerefOf (Index (Arg0, 0x18))
                Index (MTMP, 0x19) = DerefOf (Index (Arg0, 0x19))
                Return (Zero)
            }

            Method (ISPC, 0, NotSerialized)
            {
                Name (TEMB, Buffer (0x20) {})
                If ((Acquire (\_SB.PCI0.LPCB.EC0.MUEC, 0xFFFF) == Zero))
                {
                    Local0 = 0x06
                    Local1 = Zero
                    While (((Local0 < 0x1A) && (Local1 < 0x20)))
                    {
                        Index (TEMB, Local1) = DerefOf (Index (MTMP, Local0))
                        Local0++
                        Local1++
                    }

                    \_SB.PCI0.LPCB.EC0.CDTB = TEMB
                    \_SB.PCI0.LPCB.EC0.CMDB = 0xA0
                    \_SB.PCI0.LPCB.EC0.ESEB = 0x0F
                    Local0 = 0x7F
                    While ((Local0 && \_SB.PCI0.LPCB.EC0.CMDB))
                    {
                        Sleep (One)
                        Local0--
                    }

                    If ((\_SB.PCI0.LPCB.EC0.CMDB == Zero))
                    {
                        Local0 = DerefOf (Index (MTMP, Zero))
                        Local0--
                        Index (MTMP, Zero) = Local0
                        Local0 = DerefOf (Index (MTMP, 0x07))
                        Local0 += 0x09
                        Local1 = Zero
                        TEMB = \_SB.PCI0.LPCB.EC0.EDAB
                        While (((Local0 < 0x1A) && (Local1 < 0x20)))
                        {
                            Index (MTMP, Local0) = DerefOf (Index (TEMB, Local1))
                            Local0++
                            Local1++
                        }
                    }
                    Else
                    {
                        PTIE = One
                    }

                    Release (\_SB.PCI0.LPCB.EC0.MUEC)
                }

                Return (Zero)
            }

            Method (ENPC, 0, NotSerialized)
            {
                Return (Zero)
            }

            Method (RPCS, 0, NotSerialized)
            {
                Return (PTIE)
            }

            Method (RPEC, 0, NotSerialized)
            {
                Local0 = Zero
                Return (Local0)
            }
        }
    }
}

