/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20141107-64 [Jan  2 2015]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of SSDT6.aml, Fri Apr 10 15:16:18 2015
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000003D3 (979)
 *     Revision         0x01
 *     Checksum         0xA4
 *     OEM ID           "PmRef"
 *     OEM Table ID     "Cpu0Cst"
 *     OEM Revision     0x00003001 (12289)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20131115 (538120469)
 */
DefinitionBlock ("SSDT6.aml", "SSDT", 1, "PmRef", "Cpu0Cst", 0x00003001)
{

    External (_PR_.C3LT, FieldUnitObj)
    External (_PR_.C3MW, FieldUnitObj)
    External (_PR_.C6LT, FieldUnitObj)
    External (_PR_.C6MW, FieldUnitObj)
    External (_PR_.C7LT, FieldUnitObj)
    External (_PR_.C7MW, FieldUnitObj)
    External (_PR_.CDLT, FieldUnitObj)
    External (_PR_.CDLV, FieldUnitObj)
    External (_PR_.CDMW, FieldUnitObj)
    External (_PR_.CDPW, FieldUnitObj)
    External (_PR_.CFGD, FieldUnitObj)
    External (_PR_.CPU0, ProcessorObj)
    External (PDC0, IntObj)

    Scope (\_PR.CPU0)
    {
        Name (C1TM, Package (0x04)
        {
            ResourceTemplate ()
            {
                Register (FFixedHW, 
                    0x00,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000000000, // Address
                    ,)
            }, 

            One, 
            One, 
            0x03E8
        })
        Name (C3TM, Package (0x04)
        {
            ResourceTemplate ()
            {
                Register (SystemIO, 
                    0x08,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000001814, // Address
                    ,)
            }, 

            0x02, 
            Zero, 
            0x01F4
        })
        Name (C6TM, Package (0x04)
        {
            ResourceTemplate ()
            {
                Register (SystemIO, 
                    0x08,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000001815, // Address
                    ,)
            }, 

            0x02, 
            Zero, 
            0x015E
        })
        Name (C7TM, Package (0x04)
        {
            ResourceTemplate ()
            {
                Register (SystemIO, 
                    0x08,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000001816, // Address
                    ,)
            }, 

            0x02, 
            Zero, 
            0xC8
        })
        Name (CDTM, Package (0x04)
        {
            ResourceTemplate ()
            {
                Register (SystemIO, 
                    0x08,               // Bit Width
                    0x00,               // Bit Offset
                    0x0000000000001816, // Address
                    ,)
            }, 

            0x03, 
            Zero, 
            Zero
        })
        Name (MWES, ResourceTemplate ()
        {
            Register (FFixedHW, 
                0x01,               // Bit Width
                0x02,               // Bit Offset
                0x0000000000000000, // Address
                0x01,               // Access Size
                )
        })
        Name (AC2V, Zero)
        Name (AC3V, Zero)
        Name (C3ST, Package (0x04)
        {
            0x03, 
            Package (0x00) {}, 
            Package (0x00) {}, 
            Package (0x00) {}
        })
        Name (C2ST, Package (0x03)
        {
            0x02, 
            Package (0x00) {}, 
            Package (0x00) {}
        })
        Name (C1ST, Package (0x02)
        {
            One, 
            Package (0x00) {}
        })
        Name (CSTF, Zero)
        Name (GEAR, Zero)
        Method (_CST, 0, Serialized)  // _CST: C-States
        {
            If (!CSTF)
            {
                Index (C3TM, 0x02) = C3LT
                Index (C6TM, 0x02) = C6LT
                Index (C7TM, 0x02) = C7LT
                Index (CDTM, 0x02) = CDLT
                Index (CDTM, 0x03) = CDPW
                Index (DerefOf (Index (CDTM, Zero)), 0x07) = CDLV
                If (((CFGD & 0x0800) && (PDC0 & 0x0200)))
                {
                    Index (C1TM, Zero) = MWES
                    Index (C3TM, Zero) = MWES
                    Index (C6TM, Zero) = MWES
                    Index (C7TM, Zero) = MWES
                    Index (CDTM, Zero) = MWES
                    Index (DerefOf (Index (C3TM, Zero)), 0x07) = C3MW
                    Index (DerefOf (Index (C6TM, Zero)), 0x07) = C6MW
                    Index (DerefOf (Index (C7TM, Zero)), 0x07) = C7MW
                    Index (DerefOf (Index (CDTM, Zero)), 0x07) = CDMW
                }
                Else
                {
                    If (((CFGD & 0x0800) && (PDC0 & 0x0100)))
                    {
                        Index (C1TM, Zero) = MWES
                    }
                }

                CSTF = Ones
            }

            AC2V = Zero
            AC3V = Zero
            Index (C3ST, One) = C1TM
            If ((CFGD & 0x20))
            {
                Index (C3ST, 0x02) = C7TM
                AC2V = Ones
            }
            Else
            {
                If ((CFGD & 0x10))
                {
                    Index (C3ST, 0x02) = C6TM
                    AC2V = Ones
                }
                Else
                {
                    If ((CFGD & 0x08))
                    {
                        Index (C3ST, 0x02) = C3TM
                        AC2V = Ones
                    }
                }
            }

            If ((CFGD & 0x4000))
            {
                Index (C3ST, 0x03) = CDTM
                AC3V = Ones
            }

            If ((GEAR == One))
            {
                If ((CFGD & 0x08))
                {
                    Index (C3ST, 0x02) = C3TM
                    AC2V = Ones
                    AC3V = Zero
                }
                Else
                {
                    AC2V = Zero
                    AC3V = Zero
                }
            }

            If ((GEAR == 0x02))
            {
                AC2V = Zero
                AC3V = Zero
            }

            If ((AC2V && AC3V))
            {
                Return (C3ST)
            }
            Else
            {
                If (AC2V)
                {
                    Index (C2ST, One) = DerefOf (Index (C3ST, One))
                    Index (C2ST, 0x02) = DerefOf (Index (C3ST, 0x02))
                    Return (C2ST)
                }
                Else
                {
                    If (AC3V)
                    {
                        Index (C2ST, One) = DerefOf (Index (C3ST, One))
                        Index (C2ST, 0x02) = DerefOf (Index (C3ST, 0x03))
                        Index (DerefOf (Index (C2ST, 0x02)), One) = 0x02
                        Return (C2ST)
                    }
                    Else
                    {
                        Index (C1ST, One) = DerefOf (Index (C3ST, One))
                        Return (C1ST)
                    }
                }
            }
        }
    }
}

